@echo -off

if exist "fs0:%1" then
    fs0:
endif

if exist "fs1:%1" then
    fs1:
endif

if exist "fs2:%1" then
    fs2:
endif

if exist "fs3:%1" then
    fs3:
endif

if exist "fs4:%1" then
    fs4:
endif

if exist "fs5:%1" then
    fs5:
endif

if exist "fs6:%1" then
    fs6:
endif

if exist "fs7:%1" then
    fs7:
endif

if exist "fs8:%1" then
    fs8:
endif

if exist "fs9:%1" then
    fs9:
endif

if not exist "%1" then
    echo "Did not find %1"
    exit 1
endif

cd "%1"

if "%2" == "bios" then
    if "%3" == "flash" then
        # Flash with h2offt if possible, will require reboot and then will
        # shut down automatically
        if exist h2offt.efi then
           # -n to avoid reboot. Let the updater app control that
           # Ours needs to reboot before updating BIOS, otherwise it just says "Completed"
           # Ours is unhappy if the ME tool (FwUpdLcl.efi) is not there
           # It's also unhappy if the ME version is the same
           #h2offt.efi firmware.rom -all -n
           #exit %lasterror%
           # Our H2OFFT reboots automatically
           if exist h2offt-s.tag then
               # Already flashed, don't flash again
               exit 1
           else
               echo > h2offt-s.tag
               if not exist h2offt-s.tag then
                   echo "failed to create h2offt-s.tag"
                   exit 1
               endif

               echo "Running H2OFFT-S64. Waiting 2s"
               stall 2000000
               h2offt.efi firmware.cap
               # It'll reboot, so exit with error code if it doesn't
               exit 1
           endif
        endif

        echo "bios: no flash implementation found"
        exit 1
    endif

    echo "bios: unknown subcommand '%3'"
    exit 1
endif

if "%2" == "pd" then
    if "%3" == "flash-right" then
        echo "Running PD01 update, waiting 2s"
        stall 2000000
        CyPDADLt1.efi -P pd01.rom
        stall 5000000
        #map # Dummy command to succeed
        if "%lasterror%" == "0" then
            # Indicate that flashing this PD controller has succeeded
            echo > pd01.tag
            if not exist pd01.tag then
                echo "failed to create pd01.tag"
                exit 1
            endif

            exit 0
        else
            exit %lasterror%
        endif
    endif
    if "%3" == "flash-left" then
        echo "Running PD23 update, waiting 2s"
        stall 2000000
        CyPDADLt1.efi -P23 pd23.rom
        stall 5000000
        #map # Dummy command to succeed
        if "%lasterror%" == "0" then
            # Indicate that flashing this PD controller has succeeded
            echo > pd23.tag
            if not exist pd23.tag then
                echo "failed to create pd23.tag"
                exit 1
            endif
            exit 0
        else
            exit %lasterror%
        endif
    endif
    if "%3" == "tag-right" then
        echo > pd01.tag
        if not exist pd01.tag then
            echo "failed to create pd01.tag"
            exit 1
        endif
        exit 0
    endif
    if "%3" == "tag-left" then
        echo > pd23.tag
        if not exist pd23.tag then
            echo "failed to create pd23.tag"
            exit 1
        endif
        exit 0
    endif

    echo "pd: unknown subcommand '%3'"
    exit 1
endif

if "%2" == "retimer" then
    if "%3" == "flash-right" then
        echo "Running RETIMER01 update, waiting 2s"
        stall 2000000
        h2offt.efi -retimer:retimer01.cap -winux:winux.bin
        stall 5000000
        #map # Dummy command to succeed
        if "%lasterror%" == "0" then
            # Indicate that flashing this retimer has succeeded
            echo > retimer01.tag
            if not exist retimer01.tag then
                echo "failed to create retimer01.tag"
                exit 1
            endif

            exit 0
        else
            exit %lasterror%
        endif
    endif
    if "%3" == "flash-left" then
        echo "Running RETIMER23 update, waiting 2s"
        stall 2000000
        h2offt.efi -retimer:retimer23.cap -winux:winux.bin
        stall 5000000
        #map # Dummy command to succeed
        if "%lasterror%" == "0" then
            # Indicate that flashing this retimer has succeeded
            echo > retimer23.tag
            if not exist retimer23.tag then
                echo "failed to create retimer23.tag"
                exit 1
            endif
            exit 0
        else
            exit %lasterror%
        endif
    endif

    echo "retimer: unknown subcommand '%3'"
    exit 1
endif

if "%2" == "clean-tagfiles" then
    rm *.tag
    exit 0
endif

echo "unknown command '%2'"
exit 1
